//+------------------------------------------------------------------+
//|                                                    drawtalib.mq4 |
//|                                                           isabek |
//+------------------------------------------------------------------+
#property copyright "isabek"
#property library

color linescolor;
int trend1;
string trend[2];
int fontsize = 12;

void drawAll(int currenttrend, int models[][], double sp[][], int im, int modeldone, int currentmodel) {
  trend1 = currenttrend;
  trend[0] = "down";
  trend[1] = "up";

  for(int i=0; i<=im; i++) {
    if(models[i][0] >= currentmodel) {
      drawPoints(i, models, sp); //
      drawTrend(i, models, models[i][1], models[i][3], linescolor);
      drawTrend2(i, models, sp, linescolor);
      drawTarget(i, models, models[i][2], models[i][4], linescolor);
      drawTarget2(i, models, sp, linescolor);
      //drawSP(i, models, sp);
      if(models[i][0]==modeldone) {
        //drawT(i, models, sp); // 
      }
    }
  }
}

void drawPoints(int model, int models[][], double sp[][]) {
  if(trend1==0) {
    createText(getName(models, model,"p1",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][1]],High[models[model][1]]), High[models[model][1]], "1", fontsize, "Arial", Red);
    createText(getName(models, model,"p2",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][2]],Low[models[model][2]]), Low[models[model][2]], "2", fontsize, "Arial", Orange);
    createText(getName(models, model,"p3",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][3]],High[models[model][3]]), High[models[model][3]], "3", fontsize, "Arial", Yellow);
    createText(getName(models, model,"p4",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][4]],Low[models[model][4]]), Low[models[model][4]], "4", fontsize, "Arial", Lime);
    createText(getName(models, model,"p5",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][5]],High[models[model][5]]), High[models[model][5]], "5", fontsize, "Arial", SkyBlue);
    createText(getName(models, model,"p6",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][6]],Low[models[model][6]]), Low[models[model][6]], "6", fontsize, "Arial", Blue);
    //createText(getName(models, model,"sp",models[model][1],models[model][3]), Time[StrToInteger(DoubleToStr(sp[model][1],0))], sp[model][0], "", fontsize, "Arial", Purple);
  } else {
    createText(getName(models, model,"p1",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][1]],Low[models[model][1]]), Low[models[model][1]], "1", fontsize, "Arial", Red);
    createText(getName(models, model,"p2",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][2]],High[models[model][2]]), High[models[model][2]], "2", fontsize, "Arial", Orange);
    createText(getName(models, model,"p3",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][3]],Low[models[model][3]]), Low[models[model][3]], "3", fontsize, "Arial", Yellow);
    createText(getName(models, model,"p4",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][4]],High[models[model][4]]), High[models[model][4]], "4", fontsize, "Arial", Lime);
    createText(getName(models, model,"p5",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][5]],Low[models[model][5]]), Low[models[model][5]], "5", fontsize, "Arial", SkyBlue);
    createText(getName(models, model,"p6",models[model][1],models[model][3]), getcorrecttime(trend[trend1],Time[models[model][6]],High[models[model][6]]), High[models[model][6]], "6", fontsize, "Arial", Blue);
    //createText(getName(models, model,"sp",models[model][1],models[model][3]), Time[StrToInteger(DoubleToStr(sp[model][1],0))], sp[model][0], "", fontsize, "Arial", Purple);
  }
}

void createText(string name, datetime time1, double price1, string text, int fontsize, string font, color textcolor) {
  ObjectCreate(name, OBJ_TEXT, 0, time1, price1);
  ObjectSetText(name, text, fontsize, font, textcolor);
}

string getName(int models[][], int model, string name, int pointA, int pointB) {
  return("tadv|"+models[model][1]+model+"["+TimeToStr(Time[models[model][1]])+"]"+"_"+trend[trend1]+"_" +name+"."+pointA+"."+pointB);
}

datetime getcorrecttime (int hl, datetime itime, double iprice) {
  datetime newtime;
  int periods[9];

  periods[0] = PERIOD_MN1;
  periods[1] = PERIOD_W1;
  periods[2] = PERIOD_D1;
  periods[3] = PERIOD_H4;
  periods[4] = PERIOD_H1;
  periods[5] = PERIOD_M30;
  periods[6] = PERIOD_M15;
  periods[7] = PERIOD_M5;
  periods[8] = PERIOD_M1;
  newtime = itime;
  for(int i = 0; i<9; i++) {
    if(Period()>periods[i]) {
      int from, to;
      from = iBarShift(NULL, periods[i], itime, false);
      to = iBarShift(NULL, periods[i], itime+Period()*60-PERIOD_M1*60, false);
      for(int j=from; j>to; j--) {
        if(hl == 1) {
          if(iLow(NULL, periods[i], j)==iprice) {
            newtime = iTime(NULL, periods[i], j);
          }
        }
        if(hl == 0) {
          if(iHigh(NULL, periods[i], j)==iprice) {
            newtime = iTime(NULL, periods[i], j);
          }
        }
      }
    }
  }
  return(newtime);
}

void drawTrend(int model, int models[][], int point1, int point3, int modelcolor) {
  if(trend1==0) {
    createLine(getName(models, model, "trendline", point1, point3), getcorrecttime(trend1,Time[point1],High[point1]), High[point1], getcorrecttime(trend1,Time[point3], High[point3]), High[point3], modelcolor, false);
  } else {
    createLine(getName(models, model, "trendline", point1, point3), getcorrecttime(trend1,Time[point1],Low[point1]), Low[point1], getcorrecttime(trend1,Time[point3],Low[point3]), Low[point3], modelcolor, false);
  }
}

void drawTrend2(int model, int models[][], double sp[][], int modelcolor) {
  datetime time2;
  double price2;
  if(models[model][0]!=3) {
    time2 = Time[models[model][7]];
    price2 = sp[model][3];
  } else {
    time2 = Time[0];
    price2 = getValue2(models, model, trend1, "trend", 1);
  }
  if(trend1==0) {
    createLine(getName(models, model, "trendline-", models[model][1], models[model][3]), getcorrecttime(trend1,Time[models[model][3]],High[models[model][3]]), High[models[model][3]], time2, price2, modelcolor, false);
  } else {
    createLine(getName(models, model, "trendline-", models[model][1], models[model][3]), getcorrecttime(trend1,Time[models[model][3]],High[models[model][3]]), Low[models[model][3]], time2, price2, modelcolor, false);
  }
}

void createLine(string name, datetime time1, double price1, datetime time2, double price2, color linecolor, bool isray) {
  ObjectCreate(name, OBJ_TREND, 0, time1, price1, time2, price2);
  ObjectSet(name, OBJPROP_COLOR, linecolor);
  ObjectSet(name, OBJPROP_RAY, isray);
}

void drawTarget(int model, int models[][], int point2, int point4, int modelcolor) {
  if(trend1==0) {
    createLine(getName(models, model, "targetline", point2, point4), getcorrecttime(1-trend1,Time[point2],Low[point2]), Low[point2], getcorrecttime(1-trend1,Time[point4],Low[point4]), Low[point4], modelcolor, false);
  } else {
    createLine(getName(models, model, "targetline", point2, point4), getcorrecttime(1-trend1,Time[point2],High[point2]), High[point2], getcorrecttime(1-trend1,Time[point4],High[point4]), High[point4], modelcolor, false);
  }
}

void drawTarget2(int model, int models[][], double sp[][], int modelcolor) {
  datetime time2;
  double price2;
  if(models[model][0]!=3) {
    time2 = Time[models[model][7]];
    price2 = sp[model][4];
  } else {
    time2 = Time[0];
    price2 = getValue2(models, model, trend1, "target", 0);
  }
  if(trend1==0) {
    createLine(getName(models, model, "targetline-", models[model][2], models[model][4]), getcorrecttime(1-trend1,Time[models[model][4]],Low[models[model][4]]), Low[models[model][4]], time2, price2, modelcolor, false);
  } else {
    createLine(getName(models, model, "targetline-", models[model][2], models[model][4]), getcorrecttime(1-trend1,Time[models[model][4]],High[models[model][4]]), High[models[model][4]], time2,price2, modelcolor, false);
  }
}

void drawSP(int model, int models[][], double sp[][]) {
  if(trend1==0) {
    createLine(getName(models, model,"sptrend",models[model][1],models[model][3]), Time[StrToInteger(DoubleToStr(sp[model][1],0))], sp[model][0], getcorrecttime(trend[trend1],Time[models[model][1]],High[models[model][1]]), High[models[model][1]], Purple, false);
    createLine(getName(models, model,"sptarget",models[model][2],models[model][4]), Time[StrToInteger(DoubleToStr(sp[model][1],0))], sp[model][0],  getcorrecttime(trend[1-trend1],Time[models[model][2]],Low[models[model][2]]), Low[models[model][2]], Purple, false);
  } else {
    createLine(getName(models, model,"sptrend",models[model][1],models[model][3]), Time[StrToInteger(DoubleToStr(sp[model][1],0))], sp[model][0], getcorrecttime(trend[trend1],Time[models[model][1]],Low[models[model][1]]), Low[models[model][1]], Purple, false);
    createLine(getName(models, model,"sptarget",models[model][2],models[model][4]), Time[StrToInteger(DoubleToStr(sp[model][1],0))], sp[model][0],  getcorrecttime(trend[1-trend1],Time[models[model][2]],High[models[model][2]]), High[models[model][2]], Purple, false);
  }
}

void showWeak(int model, int models[][]) {
  ObjectSet(getName(models, model, "trendline", models[model][1], models[model][3]), OBJPROP_STYLE, DRAW_SECTION);
  ObjectSet(getName(models, model, "trendline-", models[model][1], models[model][3]), OBJPROP_STYLE, DRAW_SECTION);
}

void drawT(int model, int models[][], double sp[][]) {
  int tbar;
  double tprice;
  if(trend1==0) {
    tbar = models[model][7]-(models[model][6]-models[model][7]);
    tbar = models[model][7];
    tprice = sp[model][3]+(sp[model][3]-Low[models[model][6]]); //7     !
    createLine(getName(models, model,"target1",models[model][1],models[model][3]), Time[tbar-5], tprice, Time[tbar+5], tprice, LightCoral, false);
    createText(getName(models, model,"t1",models[model][1],models[model][3]), Time[tbar-1], tprice, "Target1", 10, "Arial", LightCoral);

    tbar = models[model][6]-(models[model][1]-models[model][6]);
    tbar = models[model][7];
    tprice = High[models[model][1]];
    createLine(getName(models, model,"target2",models[model][1],models[model][3]), Time[tbar-5], tprice, Time[tbar+5], tprice, LightCoral, false);
    createText(getName(models, model,"t2",models[model][1],models[model][3]), Time[tbar-1], tprice, "Target2", 10, "Arial", LightCoral);

    tbar = models[model][4]-(models[model][1]-models[model][4]);
    tbar = models[model][7];
    tprice = High[models[model][1]]+(High[models[model][1]]-Low[models[model][4]]);
    createLine(getName(models, model,"target3",models[model][1],models[model][3]), Time[tbar-5], tprice, Time[tbar+5], tprice, LightCoral, false);
    createText(getName(models, model,"t3",models[model][1],models[model][3]), Time[tbar-1], tprice, "Target3", 10, "Arial", LightCoral);
  } else {
    tbar = models[model][7]-(models[model][6]-models[model][7]);
    tbar = models[model][7];
    tprice = sp[model][3]-(High[models[model][6]]-sp[model][3]);
    createLine(getName(models, model,"target1",models[model][1],models[model][3]), Time[tbar-5], tprice, Time[tbar+5], tprice, LightCoral, false);
    createText(getName(models, model,"t1",models[model][1],models[model][3]), Time[tbar], tprice, "Target1", 10, "Arial", LightCoral);

    tbar = models[model][6]-(models[model][1]-models[model][6]);
    tbar = models[model][7];
    tprice = Low[models[model][1]];
    createLine(getName(models, model,"target2",models[model][1],models[model][3]), Time[tbar-5], tprice, Time[tbar+5], tprice, LightCoral, false);
    createText(getName(models, model,"t2",models[model][1],models[model][3]), Time[tbar], tprice, "Target2", 10, "Arial", LightCoral);

    tbar = models[model][4]-(models[model][1]-models[model][4]);
    tbar = models[model][7];
    tprice = High[models[model][1]]+(High[models[model][1]]-Low[models[model][4]]);
    createLine(getName(models, model,"target3",models[model][1],models[model][3]), Time[tbar-5], tprice, Time[tbar+5], tprice, LightCoral, false);
    createText(getName(models, model,"t3",models[model][1],models[model][3]), Time[tbar], tprice, "Target3", 10, "Arial", LightCoral);
  }
}

double getValue2(int models[][], int model, int trend1, string type, int shift) {
  double diff;
  if (type == "trend") {
    if (trend1 == 0) {
      diff = High[models[model][1]]-High[models[model][3]];
      diff = diff/(models[model][1]-models[model][3]);
      diff = diff*(models[model][1]-shift);
      diff = High[models[model][1]]-diff;
      return(diff);
    } else {
      diff = Low[models[model][3]]-Low[models[model][1]];
      diff = diff/(models[model][1]-models[model][3]);
      diff = diff*(models[model][1]-shift);
      diff = Low[models[model][1]]+diff;
      return(diff);
    }
  } else {
    if (trend1 == 0) {
      diff = Low[models[model][2]]-Low[models[model][4]];
      diff = diff/(models[model][2]-models[model][4]);
      diff = diff*(models[model][2]-shift);
      diff = Low[models[model][2]]-diff;
      return(diff);
    } else {
      diff = High[models[model][4]]-High[models[model][2]];
      diff = diff/(models[model][2]-models[model][4]);
      diff = diff*(models[model][2]-shift);
      diff = High[models[model][2]]+diff;
      return(diff);
    }    
  }
}

