//+------------------------------------------------------------------+
//|                                                       point1.mq4 |
//|                                                           isabek |
//+------------------------------------------------------------------+
#property copyright "isabek"
#property link      "."
#include <drawtalib.mqh>
#include <findtalib.mqh>

int models[][9], im; // 0-status, 1-6 - points, 7 -   
int points24[][5], ip; // 0 -status, 1-blank, 2-2, 3-3, 4-4
double sp[][5]; //   0-price, 1-bar, 2-(2-, 1-), 3 -   , 4 -    3.
bool debug = true;
int dc, dd;
string trend[2];
int extremumbars = 7, trend1 =-1;
color linescolor;

int start() {
  datetime drop_time=WindowTimeOnDropped();
  int point1 = -1;
  int i,j,k, local;
  double temp, temp2;
  trend[0] = "down";
  trend[1] = "up";

  if(drop_time>0) {
    int left_bound=WindowFirstVisibleBar();
    int right_bound=WindowFirstVisibleBar()-WindowBarsPerChart();
    if(right_bound<0) right_bound=0;

    point1 = iBarShift(Symbol(),Period(),drop_time,true);
    
    if(point1 > extremumbars) {

      point1 = find1p(point1);

      if(trend1>=0) {

        ip = -1;
        ArrayResize(points24,10000);
        ArrayInitialize(points24,0);

        ip = find24s(points24, ip, point1, trend1, debug); //      

        im = -1;
        ArrayResize(models,10000);
        ArrayInitialize(models,0);
        ArrayResize(sp,10000);
        ArrayInitialize(sp,0.0);

        im = copyModels(points24, ip, models, sp, im, 3, point1);



        linescolor = Black;

        findMR(models, sp, im, trend1, debug);



        drawAll(trend1, models, sp, im, 4, 3);


        //
      }
    }  
  }
  return(0);
}
//+------------------------------------------------------------------+

int find1p(int point1) {
  double drop_price=WindowPriceOnDropped();
  int pointlow = iLowest(NULL, 0, MODE_LOW, (extremumbars*2+1), point1-extremumbars);
  int pointhigh = iHighest(NULL, 0, MODE_HIGH, (extremumbars*2+1), point1-extremumbars);

  if( (High[pointhigh] - drop_price) > (drop_price - Low[pointlow]) ) {
    if( pointlow == getExtremum (pointlow, 1, 7) ) {
      trend1 = 1;
      if(debug) Print(" 1 . Up-.");
      return(pointlow);
    }
  } else {
    if( pointhigh == getExtremum (pointhigh, 0, 7) ) {
      trend1 = 0;
      if(debug) Print(" 1 . Down-.");
      return(pointhigh);
    }
  }
}


