//+------------------------------------------------------------------+
//|                                                       point1.mq4 |
//|                                                           isabek |
//+------------------------------------------------------------------+
#property copyright "isabek"
#property link      "."
#include <drawtalib.mqh>
#include <findtalib.mqh>

int firstpoint[2][1];
int models[][9], im=-1; // 0-status, 1-6 - points, 7 -   
int points24[][5], ip=-1; // 0 -status, 1-blank, 2-2, 3-3, 4-4
double sp[][5]; //   0-price, 1-bar, 2-(2-, 1-), 3 -   
bool debug = false;
int dc, dd;
string trend[2];
int extremumbars = 7, trend1 =-1;
color linescolor;
bool isup, isdown;
 
int start() {
  datetime drop_time=WindowTimeOnDropped();
  int point1 = -1;
  int k;
  trend[0] = "down";
  trend[1] = "up";

  firstpoint[0][0] = 0; // down-trend, prev bar`
  firstpoint[1][0] = 0; // up-trend, prev bar`

  if(drop_time>0) {    

    point1 = iBarShift(Symbol(),Period(),drop_time,true);

    if(point1 > 7) {

      for(k=point1; k>0; k--) {

        find1p(k);

        if(isup) {
          if(debug) {
            Print(TimeToStr(Time[firstpoint[1][0]]));
            Print(" 1 . Up-.");
          }
          ip = -1;
          ArrayResize(points24,10000);
          ArrayInitialize(points24,0);
          trend1 = 1;
          ip = find24s(points24, ip, firstpoint[1][0], trend1, debug); //      
          im = -1;
          ArrayResize(models,10000);
          ArrayInitialize(models,0);
          ArrayResize(sp,10000);
          ArrayInitialize(sp,0.0);
          im = copyModels(points24, ip, models, sp, im, 3, firstpoint[1][0]);
          linescolor = Black;
          findMR(models, sp, im, trend1, debug);
          drawAll(trend1, models, sp, im, 4, 3);
        }

        if(isdown) {
          if(debug) {
            Print(TimeToStr(Time[firstpoint[0][0]]));
            Print(" 1 . Down-.");
          }
          ip = -1;
          ArrayResize(points24,10000);
          ArrayInitialize(points24,0);
          trend1 = 0;
          ip = find24s(points24, ip, firstpoint[0][0], trend1, debug); //      
          im = -1;
          ArrayResize(models,10000);
          ArrayInitialize(models,0);
          ArrayResize(sp,10000);
          ArrayInitialize(sp,0.0);
          im = copyModels(points24, ip, models, sp, im, 3, firstpoint[0][0]);
          linescolor = Black;
          findMR(models, sp, im, trend1, debug);
          drawAll(trend1, models, sp, im, 4, 3);
        }

      }// end of k
    }
  }
  return(0);
}

int getExtremum(int pointx, int updown, int ebars) {
  if(updown == 1) {
    return (iLowest(NULL, 0, MODE_LOW, ebars*2+1, pointx-ebars));
  }
  if(updown == 0) {
    return (iHighest(NULL, 0, MODE_HIGH, ebars*2+1, pointx-ebars));
  }
  return (-1);
}

void find1p(int point1) {
  double drop_price=WindowPriceOnDropped();
  int pointlow = iLowest(NULL, 0, MODE_LOW, (extremumbars*2+1), point1-extremumbars);
  int pointhigh = iHighest(NULL, 0, MODE_HIGH, (extremumbars*2+1), point1-extremumbars);

  isup = false;
  isdown = false;

  if( pointlow == getExtremum (pointlow, 1, extremumbars) ) {
    if(firstpoint[1][0] != pointlow  && pointlow > extremumbars) {
      firstpoint[1][0] = pointlow;
      isup = true;
    }
  } 

  if( pointhigh == getExtremum (pointhigh, 0, extremumbars) ) {
    if(firstpoint[0][0] != pointhigh && pointhigh > extremumbars) {
      firstpoint[0][0] = pointhigh;
      isdown = true;
    }
  }
}

